#include <stdint.h>
#include "noise_hw.h"

sbit NOISE_CS 	at GPIO_PIN28_bit;
sbit NOISE_INT 	at GPIO_PIN3_bit;

void system_setup( void );

void main()
{
    //Local Decalartions
    uint8_t buffer[20] = { 0 };
    uint32_t value = 0;
    uint16_t threshold = 50;

    //Setup
    system_setup();

    noise_set_threshold( threshold );

    //Loop
    while(1)
    {
        value = ADC_Read( 4 );
        LongToStr( value, buffer );
        UART1_Write_Text( buffer );
        UART1_Write_Text( "\r\n" );
        Delay_ms(20);
        if( NOISE_INT == 0 );  // Do nothing
        else
            UART1_Write_Text( "Interrupt!!!!!!\r\n" );
    }

}

void system_setup( void )
{
    //GPIOs
    GPIO_Digital_Output( &GPIO_PORT_24_31, _GPIO_PINMASK_4 );
    GPIO_Digital_Input( &GPIO_PORT_00_07, _GPIO_PINMASK_3 );

    //UART
    UART1_Init( 9600 );
    Delay_ms(100);
    UART1_Write_Text( "UART Initialized\r\n" );

    //SPI
    SPIM1_Init_Advanced( _SPI_MASTER_CLK_RATIO_4, _SPI_CFG_PHASE_CAPTURE_RISING |
		     _SPI_CFG_POLARITY_IDLE_LOW | _SPI_CFG_SS_AUTO_DISABLE |
		     _SPI_CFG_FIFO_DISABLE, _SPI_SS_LINE_NONE );
    Delay_ms(200);
    UART1_Write_Text( "SPI Initialized\r\n" );

    //ADC
    ADC_Init();
    Delay_ms(200);
    UART1_Write_Text( "ADC Initialized\r\n" );

    //Noise Click
    noise_init();
    UART1_Write_Text( "Noise Click Initialized\r\n" );

}